#include <stdio.h>
#include <math.h>
//#include "newsLib.h"

#define MX 15
#define BUFFER_LENGTH 256

// do not read from the ORACLE_FILE directly --
// you won't have it when your solution is being judged.

#define ORACLE_FILE "oracle.in"

#define ORACLE_LOG "news.log"

int solx, soly;
char logBuffer[BUFFER_LENGTH];

static void logMessage(char *s) {
	FILE *fp = fopen(ORACLE_LOG, "a");
	fprintf(fp, "%s\n", s);
	fclose(fp);
}

static void error(char *s) {
	printf("NEWS: Error: %s\n", s);
	exit(-1);
}

int initialize() {
	freopen(ORACLE_FILE, "r", stdin);
	scanf("%d%d ",&solx,&soly);
}

static void cleanup() {
	// cleanup memory...
	solx = soly = 0;
}

/*
1: N/S
2: NE/SW
3: E/W
4: NW/SE
*/

int sign(int x) {
	if (x > 0) return 1;
	if (x < 0) return -1;
	return 0;
}

int checkCoordinates(int x, int y) {
	if (x < 0 || y < 0 || x >= MX || y >= MX) {
		error("Coordinates out of range.");
	}
}

int Oracle( int x, int y, int slope ) {
	int t, ret;

	sprintf(logBuffer,"Oracle (x=%d, y=%d, slope=%d);", x, y, slope);
	logMessage(logBuffer);

	if (slope < 1 || slope > 4)
		error("Bad slope!");

	initialize();

	checkCoordinates(x, y);

	switch(slope) {
		case 1:
			ret = sign(solx - x);
			break;
		case 2:
			ret = sign((solx - x) - (soly - y));
			break;
		case 3:
			ret = sign(y - soly);
			break;
		case 4:
			ret = sign((solx - x) + (soly - y));
			break;
	}

	cleanup();

	sprintf(logBuffer, "returns %d", ret);
	logMessage(logBuffer);
	return ret;
}

void Decide( int x, int y ) {
	FILE *fp = fopen("news.out", "w");

	sprintf(logBuffer,"Decide (x=%d, y=%d);", x, y);
	logMessage(logBuffer);

	initialize();

	fprintf(fp, "%d %d\n", x, y);
	fclose(fp);


	checkCoordinates(x, y);
	if (x == solx && y == soly) {
		logMessage("CORRECT!");
		exit(0);
	} else {
		sprintf(logBuffer,"Incorrect. Answer is (%d, %d).", solx, soly);
		logMessage(logBuffer);
		exit(1);
	}
}
